﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;


namespace ПервоначальноеРаспределениеПоМинимальному
{
    internal class Decision
    {
        public static int m; // Количество поставщиков
        public static int n; // Количесвтво потребителей
        public static int[,] matrxA;//матрица затрат на перевозк и хранение единицы процукции
        public static int[] mMatr;//вектор мощности поставщиков
        public static int[] nMatr;//вектор спроса потребителей
        bool[,] Filled; // Массив для пометки клеток куда сделана поставка
        public static int[,] divisionArray; // Распределение поставок
        public void GetRazmer(ref int a, string text)
        {
            while (true)
            {
                try
                {
                    Console.Write($"Введите количество {text}: ");
                    a = Convert.ToInt32(Console.ReadLine());
                    if (a < 2)
                    {
                        Console.WriteLine($"{text} должно быть не менее двух! Повторите ввод");
                    }
                    else
                    {
                        break;
                    }
                }
                catch
                {
                    Console.WriteLine("Введены некорректные данные!");
                }
            }
        }

        public void GetMatr(ref int[,] matr, int r, int c, string text)
        {
            int i = 0, j = 0;//переменные для циклов
            Console.WriteLine($"Ввод таблицы затрат на {text} продукции:");//ввод данных в таблицу затрат
            for (i = 0; i < matr.GetLength(0); i++)
            {
                for (j = 0; j < matr.GetLength(1); j++)
                {

                    while (true)
                    {
                        try
                        {
                            Console.Write($"Введите стоимость {text} от {i + 1} поставщика  к {j + 1} потребителю: ");
                            matr[i, j] = Convert.ToInt32(Console.ReadLine());
                            break;
                        }
                        catch
                        {
                            Console.WriteLine("Введены некорректные данные!");
                        }
                    }

                }
                Console.WriteLine();
            }

            Console.WriteLine($"Таблица затрат на {text} продукции:");//вывод таблицы затрат на экран
            for (i = 0; i < matr.GetLength(0); i++)
            {
                for (j = 0; j < matr.GetLength(1); j++)
                {
                    Console.Write(matr[i, j] + "\t");
                }
                Console.WriteLine();
            }
            char otv;//переменная для диалога с пользователем
            //Изменение матрицы
            while (true)
            {
                while (true)
                {
                    try
                    {
                        Console.Write("\nХотите изменить данные о таблице?\nДа(любая клавиша)/Нет(N)\nОтвет: ");
                        otv = Convert.ToChar(Console.ReadLine());
                        break;
                    }
                    catch
                    {
                        Console.WriteLine("Введены некорректные данные!");
                    }
                }
                if (otv.Equals('n') || otv.Equals('т') || otv.Equals('N') || otv.Equals('Т'))
                {
                    break;
                }
                else
                {
                    Console.Write("Введите номер поставщика, нажмите Enter, затем номер потребителя, который вы хотите изменить\nОтвет:\n");
                    while (true)
                    {
                        i = Convert.ToInt32(Console.ReadLine());
                        j = Convert.ToInt32(Console.ReadLine());
                        if (i < c + 1 && j < r + 1)
                        {
                            while (true)
                            {
                                try
                                {
                                    Console.Write("Введите новое значение: ");
                                    int temp = Convert.ToInt32(Console.ReadLine());
                                    if (temp != 0)
                                    {
                                        Console.WriteLine($" Была изменена {i} {j} ячейка таблицы c {matr[i - 1, j - 1]} на {temp}");
                                        matr[i - 1, j - 1] = temp;
                                        break;
                                    }
                                    else
                                    {
                                        Console.WriteLine("Вы ввели нулевое значение! Повторите ввод");
                                    }
                                }
                                catch
                                {
                                    Console.WriteLine("Введены некорректные данные!");
                                }
                            }
                            break;
                        }
                        else
                        {
                            Console.WriteLine("Введенная размерность не соответствует матрице! Повторите ввод");
                        }
                    }
                }
            }
        }
        public void vector(ref int[] m, int i, int j, string text)
        {
            Console.WriteLine($"Ввод данных о количестве продукции {text}:");//ввод данных в вектор мощности поставщиков
            for (i = 0; i < m.Length; i++)
            {
                while (true)
                {
                    try
                    {
                        Console.Write($"Введите количество продукции у {i + 1} {text}: ");
                        m[i] = Convert.ToInt32(Console.ReadLine());
                        break;
                    }
                    catch
                    {
                        Console.WriteLine("Введены некорректные данные!");
                    }
                }
            }
        }
        public void GetVectora(ref int[] m, ref int[] n)
        {
            int i = 0, j = 0;//переменные для циклов
            int valueM = 0, valueN = 0;
            while (true)
            {
                vector(ref m, i, j, "Поставщика");
                vector(ref n, i, j, "Потребителя");
                for (i = 0; i < m.Length; i++)
                {
                    valueM += m[i];
                }
                for (i = 0; i < n.Length; i++)
                {
                    valueN += n[i];
                }
                if (valueM == valueN)
                {
                    break;
                }
                else//проверка на равенство суммы элементов векторов
                {
                    Console.WriteLine("Вектор мощности (m) и cпроса (n) должны быть равны, повторите ввод!");
                    valueM = 0;
                    valueN = 0;
                }
            }
            Console.WriteLine("Вектор мощности (m):");//вывод на экран
            for (i = 0; i < m.Length; i++)
            {
                Console.Write($"{m[i]} ");
            }
            Console.WriteLine("\nВектор спроса (n):");//вывод на экран
            for (i = 0; i < n.Length; i++)
            {
                Console.Write($"{n[i]} ");
            }
        }
        public void GetNewMassive(ref string[,] d, int[] a, int[] b, int[,] c)
        {
            // Цикл для заполнения спросов в новом массиве
            for (int i = 0; i < b.Length; i++)
            {
                d[0, i + 1] = Convert.ToString(b[i]);
            }
            // Цикл для заполнения мощностей поставщиков в новом массиве
            for (int j = 0; j < a.Length; j++)
            {
                d[j + 1, 0] = Convert.ToString(a[j]);
            }
            // Цикл для заполнения суммы массивов
            for (int i = 0; i < c.GetLength(0); i++)
            {
                for (int j = 0; j < c.GetLength(1); j++)
                {
                    d[i + 1, j + 1] = Convert.ToString(c[i, j]);
                }
            }
        }
        public int GetDistribution() //Выполнения распредления и подсчёта суммы
        {
            Filled = new bool[mMatr.Length, nMatr.Length];
            divisionArray = new int[mMatr.Length, nMatr.Length];
            int F = 0;
            int[,] matrFirst = new int[mMatr.Length, nMatr.Length]; ; // Матрица для первоначального распределения
            Array.Copy(matrxA, matrFirst, matrxA.Length);
            int[] M = new int[mMatr.Length]; // Массив для мощности поставщиков в распределение
            int[] N = new int[nMatr.Length]; // Массив для спроаса потребителей в распределение
            Array.Copy(mMatr, M, mMatr.Length);
            Array.Copy(nMatr, N, nMatr.Length);
            int sum = 1; // Сумма мощности поставщиков
            // Первоначальное распределение по минимальному элементу
            while (sum != 0) // Если мощность поставщиков равна 0, то цикл прекратится
            {
                int min = GetMaxMatr(matrxA);
                int iMin = 0;
                int jMin = 0;
                for (int i = 0; i < mMatr.Length; i++)
                {
                    for (int j = 0; j < nMatr.Length; j++)
                    {
                        if (matrFirst[i, j] <= min && matrFirst[i, j] != 0) // Если наименьшая и не равна 0 (ещё не делали поставку)
                        {
                            min = matrFirst[i, j];
                            iMin = i;
                            jMin = j;
                        }
                    }
                }
                matrFirst[iMin, jMin] = 0; // Зануляем самый минимальный элемент
                if (M[iMin] > 0 && N[jMin] > 0)
                {
                    if (N[jMin] < M[iMin]) // Если спрос меньше предложения
                    {
                        F += matrxA[iMin, jMin] * N[jMin];
                        divisionArray[iMin, jMin] = N[jMin];
                        Filled[iMin, jMin] = true;
                        M[iMin] -= N[jMin];
                        N[jMin] = 0;
                    }
                    else if (N[jMin] > M[iMin]) // Если спрос больше предложения
                    {
                        F += matrxA[iMin, jMin] * M[iMin];
                        divisionArray[iMin, jMin] = M[iMin];
                        Filled[iMin, jMin] = true;
                        N[jMin] -= M[iMin];
                        M[iMin] = 0;
                    }
                    else
                    {
                        F += matrxA[iMin, jMin] * M[iMin];
                        divisionArray[iMin, jMin] = M[iMin];
                        Filled[iMin, jMin] = true;
                        N[jMin] = 0;
                        M[iMin] = 0;
                    }
                }
                sum = 0;
                for (int i = 0; i < M.Length; i++) // Подсчёт суммы мощности поставщиков
                {
                    sum += M[i];
                }
            }
            return F;
        }
        public static int GetMaxMatr(int[,] matr)
        {
            int max = 0;
            for (int i = 0; i < matr.GetLength(0); i++)
            {
                for (int j = 0; j < matr.GetLength(1); j++)
                {
                    if (max < matr[i, j])
                    {
                        max = matr[i, j];
                    }
                }
            }
            return max;
        }
    }
}
