﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ПервоначальноеРаспределениеПоСЗ
{
    internal class Program
    {
        [STAThread]
        static void Main(string[] args)
        {
            while (true)
            {
                Console.WriteLine("Нахождение первоначального распределения транспортной задачи по метод северо-заподного угла");
                FileWork fileWork = new FileWork();
                Decision decision = new Decision();
                char otv; // Переменная для диалога с пользователем
                while (true)
                {
                    try
                    {
                        Console.Write("\nВыберите способ ввода входных данных?\nЧерез внешний .csv файл(Y)/Вручную(N)\nОтвет: ");
                        otv = Convert.ToChar(Console.ReadLine());
                        break;
                    }
                    catch
                    {
                        Console.WriteLine("Введены некорректные данные!");
                    }
                }
                if ((otv.Equals('Y') || otv.Equals('y') || otv.Equals('н') || otv.Equals('Н')))
                {
                    Console.Clear();
                    fileWork.VvodNameFile();
                    decision.matrxD = fileWork.GetData();
                    if (fileWork.Proverka(decision.matrxD) == true)
                    {
                        Console.ReadKey();
                        break;
                    }
                }
                else if ((otv.Equals('N') || otv.Equals('N') || otv.Equals('Т') || otv.Equals('т')))
                {
                    decision.GetRazmer(ref decision.r, "Потребителей"); //ввод потребителей(размерности по столбцам)
                    decision.GetRazmer(ref decision.c, "Поставщиков"); //ввод поставщиков(размерности по стокам)
                    decision.matrxA = new int[decision.r, decision.c];//матрица затрат на перевозк и хранение единицы процукции
                    Console.Clear();
                    decision.GetMatr(ref decision.matrxA, decision.r, decision.c, "Перевозки и Хранения");
                    Console.Clear();
                    decision.m = new int[decision.r];//вектор мощности поставщиков
                    decision.n = new int[decision.c];//вектор спроса потребителей
                    decision.GetVectora(ref decision.m, ref decision.n);
                    Console.Clear();
                    decision.matrxD = new string[decision.r + 1, decision.c + 1];//матрица для распределения с дополнительной строкой и столбцом для спроса и предложения
                    decision.GetNewMassive(ref decision.matrxD, decision.m, decision.n, decision.matrxA); // Формирование новой матрицы
                }
                double summa; // Переменная для хранения значения целевой функции
                summa = decision.GetDistribution(ref decision.matrxD);
                Console.Clear();
                FileWork.SaveNameFile();
                Console.WriteLine("Результат распределения занесён в файл " + FileWork.pathEnd);// вывод матрицы с рапределёнными поставками
                fileWork.Record(decision.matrxD,  summa);
                while (true)
                {
                    try
                    {
                        Console.Write("\nПовторить программу?\nДа(Y)/Нет(N)\nОтвет: ");
                        otv = Convert.ToChar(Console.ReadLine());
                        break;
                    }
                    catch
                    {
                        Console.WriteLine("Введены некорректные данные!");
                    }
                }
                if (!(otv.Equals('Y') || otv.Equals('y') || otv.Equals('н') || otv.Equals('Н')))
                {
                    break;
                }
                else if (!(otv.Equals('N') || otv.Equals('N') || otv.Equals('Т') || otv.Equals('т')))
                {
                    Console.Clear();
                }
                else
                {
                    Console.Clear();
                }
            }
        }
    }
}
