﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace МеиодПотенциаоловПоМинимальному_Элементу
{
    internal class VhodData
    {
        public void vvod()
        {
            GetRazmer(ref Decision.n, "Потребителей"); //ввод потребителей(размерности по столбцам)
            GetRazmer(ref Decision.m, "Поставщиков"); //ввод поставщиков(размерности по стокам)
            Decision.matr = new int[Decision.m, Decision.n];//матрица затрат на перевозк и хранение единицы процукции
            Console.Clear();
            GetMatr(ref Decision.matr, Decision.m, Decision.n, "Перевозки и Хранения");
            Console.Clear();
            Decision.mMatr = new int[Decision.m];//вектор мощности поставщиков
            Decision.nMatr = new int[Decision.n];//вектор спроса потребителей
            GetVectora(ref Decision.mMatr, ref Decision.nMatr);
            Console.Clear();
        }
        public static void GetRazmer(ref int a, string text)
        {
            while (true)
            {
                try
                {
                    Console.Write($"Введите количество {text}: ");
                    a = Convert.ToInt32(Console.ReadLine());
                    if (a < 2)
                    {
                        Console.WriteLine($"{text} должно быть не менее двух! Повторите ввод");
                    }
                    else
                    {
                        break;
                    }
                }
                catch
                {
                    Console.WriteLine("Введены некорректные данные!");
                }
            }
        }

        public static void GetMatr(ref int[,] matr, int r, int c, string text)
        {
            int i = 0, j = 0;//переменные для циклов
            Console.WriteLine($"Ввод таблицы затрат на {text} продукции:");//ввод данных в таблицу затрат
            for (i = 0; i < matr.GetLength(0); i++)
            {
                for (j = 0; j < matr.GetLength(1); j++)
                {

                    while (true)
                    {
                        try
                        {
                            Console.Write($"Введите стоимость {text} от {i + 1} поставщика  к {j + 1} потребителю: ");
                            matr[i, j] = Convert.ToInt32(Console.ReadLine());
                            break;
                        }
                        catch
                        {
                            Console.WriteLine("Введены некорректные данные!");
                        }
                    }

                }
                Console.WriteLine();
            }
            ShowMatr(); // вывод таблицы затрат на экран
            char otv;//переменная для диалога с пользователем
            while (true) //Изменение матрицы
            {
                while (true)
                {
                    try
                    {
                        Console.Write("\nХотите изменить данные о таблице?\nДа(любая клавиша)/Нет(N)\nОтвет: ");
                        otv = Convert.ToChar(Console.ReadLine());
                        break;
                    }
                    catch
                    {
                        Console.WriteLine("Введены некорректные данные!");
                    }
                }
                if (otv.Equals('n') || otv.Equals('т') || otv.Equals('N') || otv.Equals('Т'))
                {
                    break;
                }
                else
                {
                    Console.Write("Введите номер поставщика, нажмите Enter, затем номер потребителя, который вы хотите изменить\nОтвет:\n");
                    while (true)
                    {
                        i = Convert.ToInt32(Console.ReadLine());
                        j = Convert.ToInt32(Console.ReadLine());
                        if (i < c + 1 && j < r + 1)
                        {
                            while (true)
                            {
                                try
                                {
                                    Console.Write("Введите новое значение: ");
                                    int temp = Convert.ToInt32(Console.ReadLine());
                                    if (temp != 0)
                                    {
                                        Console.WriteLine($" Была изменена {i} {j} ячейка таблицы c {matr[i - 1, j - 1]} на {temp}");
                                        matr[i - 1, j - 1] = temp;
                                        break;
                                    }
                                    else
                                    {
                                        Console.WriteLine("Вы ввели нулевое значение! Повторите ввод");
                                    }
                                }
                                catch
                                {
                                    Console.WriteLine("Введены некорректные данные!");
                                }
                            }
                            break;
                        }
                        else
                        {
                            Console.WriteLine("Введенная размерность не соответствует матрице! Повторите ввод");
                        }
                    }
                }
            }
        }
        public static void vector(ref int[] m, int i, int j, string text)
        {
            Console.WriteLine($"Ввод данных о количестве продукции {text}:");//ввод данных в вектор мощности поставщиков
            for (i = 0; i < m.Length; i++)
            {
                while (true)
                {
                    try
                    {
                        Console.Write($"Введите количество продукции у {i + 1} {text}: ");
                        m[i] = Convert.ToInt32(Console.ReadLine());
                        break;
                    }
                    catch
                    {
                        Console.WriteLine("Введены некорректные данные!");
                    }
                }
            }
        }
        public static void GetVectora(ref int[] m, ref int[] n)
        {
            int i = 0, j = 0;//переменные для циклов
            int valueM = 0; // Сумма мощности поставщиков
            int valueN = 0; // Сумма спроса потребителей
            while (true)
            {
                vector(ref m, i, j, "Поставщика");
                vector(ref n, i, j, "Потребителя");
                for (i = 0; i < m.Length; i++)
                {
                    valueM += m[i];
                }
                for (i = 0; i < n.Length; i++)
                {
                    valueN += n[i];
                }
                if (valueM == valueN)
                {
                    break;
                }
                else//проверка на равенство суммы элементов векторов
                {
                    Console.WriteLine("Вектор мощности (m) и cпроса (n) должны быть равны, повторите ввод!");
                    valueM = 0;
                    valueN = 0;
                }
            }
            ShowVectorM();
            ShowVectorN();
        }
        public static void ShowMatr() //вывод таблицы затрат на экран
        {
            int i, j;
            Console.WriteLine($"Таблица затрат на производство и хранение продукции:");
            for (i = 0; i < Decision.matr.GetLength(0); i++)
            {
                for (j = 0; j < Decision.matr.GetLength(1); j++)
                {
                    Console.Write(Decision.matr[i, j] + "\t");
                }
                Console.WriteLine();
            }
        }
        public static void ShowVectorM()
        {
            int i;
            Console.WriteLine("Вектор мощности (m):");//вывод на экран
            for (i = 0; i < Decision.mMatr.Length; i++)
            {
                Console.Write($"{Decision.mMatr[i]} ");
            }
        }
        public static void ShowVectorN()
        {
            int i;
            Console.WriteLine("\nВектор спроса (n):");//вывод на экран
            for (i = 0; i < Decision.nMatr.Length; i++)
            {
                Console.Write($"{Decision.nMatr[i]} ");
            }
        }
    }
}
