﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ПервоначальноеРаспределениеПоМинимальному
{
    internal class Program
    {
        [STAThread]
        static void Main(string[] args)
        {
            while (true)
            {
                Console.WriteLine("Нахождение первоначального распределения транспортной задачи по метод северо-заподного угла");
                FileWork fileWork = new FileWork();
                Decision decision = new Decision();
                char otv; // Переменная для диалога с пользователем
                while (true)
                {
                    try
                    {
                        Console.Write("\nВыберите способ ввода входных данных?\nЧерез внешний .csv файл(Y)/Вручную(N)\nОтвет: ");
                        otv = Convert.ToChar(Console.ReadLine());
                        break;
                    }
                    catch
                    {
                        Console.WriteLine("Введены некорректные данные!");
                    }
                }
                if ((otv.Equals('Y') || otv.Equals('y') || otv.Equals('н') || otv.Equals('Н')))
                {
                    Console.Clear();
                    fileWork.VvodNameFile();
                    fileWork.GetData();
                    if (fileWork.Proverka() == true)
                    {
                        Console.ReadKey();
                        break;
                    }
                }
                else if ((otv.Equals('N') || otv.Equals('N') || otv.Equals('Т') || otv.Equals('т')))
                {
                    decision.GetRazmer(ref Decision.m, "Потребителей"); //ввод потребителей(размерности по столбцам)
                    decision.GetRazmer(ref Decision.n, "Поставщиков"); //ввод поставщиков(размерности по стокам)
                    Decision.matrxA = new int[Decision.m, Decision.n];//матрица затрат на перевозк и хранение единицы процукции
                    Console.Clear();
                    decision.GetMatr(ref Decision.matrxA, Decision.n, Decision.m, "Перевозки и Хранения");
                    Console.Clear();
                    Decision.mMatr = new int[Decision.m];//вектор мощности поставщиков
                    Decision.nMatr = new int[Decision.n];//вектор спроса потребителей
                    decision.GetVectora(ref Decision.mMatr, ref Decision.nMatr);
                    Console.Clear();
                }
                int summa; // Переменная для хранения значения целевой функции
                summa = decision.GetDistribution(); // Выполнения распределения
                Console.Clear();
                FileWork.SaveNameFile();
                Console.WriteLine("Результат распределения занесён в файл " + FileWork.pathEnd);// вывод матрицы с рапределёнными поставками
                fileWork.Record(summa, Decision.divisionArray);
                while (true)
                {
                    try
                    {
                        Console.Write("\nПовторить программу?\nДа(Y)/Нет(N)\nОтвет: ");
                        otv = Convert.ToChar(Console.ReadLine());
                        break;
                    }
                    catch
                    {
                        Console.WriteLine("Введены некорректные данные!");
                    }
                }
                if (!(otv.Equals('Y') || otv.Equals('y') || otv.Equals('н') || otv.Equals('Н')))
                {
                    break;
                }
                else if (!(otv.Equals('N') || otv.Equals('N') || otv.Equals('Т') || otv.Equals('т')))
                {
                    Console.Clear();
                }
                else
                {
                    Console.Clear();
                }
            }
        }
    }
}
