﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Симлекс_метод
{
    internal class FileWork
    {
        public string pathStart; // Путь к исходному файлу
        public string pathEnd; // Путь к конечному файлу
        public void GetData(ref int n, ref int m, ref double[,] main, ref double[] res, ref double[] dohod)
        {
            var lines = File.ReadAllLines(pathStart);
            string[][] text = new string[lines.Length][];
            for (int i = 0; i < text.Length; i++)
            {
                text[i] = lines[i].Split(';');
            }
            m = text.Length - 2;
            n = text[text.Length-1].Length - 2;
            main = new double[m, n];
            dohod = new double[n];
            int k = 0;
            foreach (string[] line in text)
            {
                int j = 0;
                foreach (string s in line)
                {
                    if(k > 1 && j == 1)
                    {
                        Array.Resize(ref res, res.Length + 1);
                        res[res.Length - 1] = Convert.ToInt32(s);
                    }
                    if (k > 1 && j > 1)
                    {
                        main[k-2,j-2] = Convert.ToInt32(s);
                    }
                    j++;
                }
                k++;
            }
        }
        public bool Proverka()
        {
            var lines = File.ReadAllLines(pathStart);
            string[][] text = new string[lines.Length][];
            for (int i = 0; i < text.Length; i++)
            {
                text[i] = lines[i].Split(';');
            }
            int k = 0;
            foreach (string[] line in text)
            {
                int j = 0;
                foreach (string s in line)
                {
                    if (k > 1 && j == 1)
                    {
                        try
                        {
                            if (Convert.ToDouble(s) < 0)
                            {
                                Console.WriteLine("Запасы сырья не могут быть отрицательными!!! Исправьте входные данные");
                                return true;
                            }
                        }
                        catch
                        {
                            Console.WriteLine("Во входных данных присутствуют некоректные данные, исправьте их и попробуйте снова");
                            return true;
                        }
                    }
                    if (k > 1 && j > 1)
                    {
                        try
                        {
                            if (Convert.ToDouble(s) < 0)
                            {
                                Console.WriteLine("Расход сырья не может быть отрицательным!!! Исправьте входные данные");
                                return true;
                            }
                        }
                        catch
                        {
                            Console.WriteLine("Во входных данных присутствуют некоректные данные, исправьте их и попробуйте снова");
                            return true;
                        }
                    }
                    j++;
                }
                k++;
            }
            return false;
        }
        public void Conclusion(double r, double[] a, double[,] b)
        {
            for (int i = 0; i < r; i++)
            {
                File.AppendAllText(pathEnd, $"x{i + 1} =;{a[i]};");
                File.AppendAllText(pathEnd, Environment.NewLine);
            }
            File.AppendAllText(pathEnd, $"F =;{Math.Round(Math.Abs(b[b.GetLength(0) - 1, b.GetLength(1) - 1]), 3)};");
        }
    }
}
